SystemOrganization addCategory: #ConfigurationOfPlatypus!

Object subclass: #ConfigurationOfPlatypus
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPlatypus'!

!ConfigurationOfPlatypus class methodsFor: 'development support' stamp: 'AlainPlantec 4/30/2012 22:12'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPlatypus class methodsFor: 'private' stamp: 'AlainPlantec 4/30/2012 22:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPlatypus class methodsFor: 'private' stamp: 'AlainPlantec 4/30/2012 22:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPlatypus class methodsFor: 'private' stamp: 'AlainPlantec 4/30/2012 22:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPlatypus class methodsFor: 'metacello tool support' stamp: 'AlainPlantec 4/30/2012 22:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPlatypus class methodsFor: 'loading' stamp: 'AlainPlantec 4/30/2012 22:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPlatypus class methodsFor: 'loading' stamp: 'AlainPlantec 4/30/2012 22:12'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPlatypus class methodsFor: 'loading' stamp: 'AlainPlantec 4/30/2012 22:12'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPlatypus class methodsFor: 'accessing' stamp: 'AlainPlantec 4/30/2012 22:12'!
project

	^self new project! !

!ConfigurationOfPlatypus class methodsFor: 'development support' stamp: 'AlainPlantec 4/30/2012 22:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPlatypus methodsFor: 'baselines' stamp: 'AlainPlantec 6/10/2012 20:27'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #'pharo' do: [
		spec blessing: #default.
		spec repository: 'http://ss3.gemstone.com/ss/Platypus'.
		spec package: 'SmaCC' with: [ 
			spec repository: 'http://squeaksource.com/SmaccDevelopment'].
		spec package: 'SmaCCDev' with: [ 
			spec repository: 'http://squeaksource.com/SmaccDevelopment'].
		spec project: 'PetitParser for Moose' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					file: 'ConfigurationOfPetitParser';
					version: 'default';
					repository: 'http://source.lukas-renggli.ch/petit' ].
		spec package: 'PetitSmalltalk' with: [
			spec requires: #('PetitParser for Moose').
			spec repository: 'http://www.squeaksource.com/PetitJava'].
		spec package: 'PetitAnalyser' with: [
			spec requires: #('PetitParser for Moose').
			spec repository: 'http://source.lukas-renggli.ch/petit'].
		spec package: 'PetitTests' with: [
			spec requires: #('PetitParser for Moose').
			spec repository: 'http://source.lukas-renggli.ch/petit'].
		spec project: 'Glamour for Platypus' with: [
			spec requires: #('PetitParser for Moose').
			spec
				className: 'ConfigurationOfGlamour';
				file: 'ConfigurationOfGlamour';
				version: 'default';
				repository: 'http://www.squeaksource.com/Glamour'.
			spec ].
		spec project: 'Platypus' with: [
			spec requires: 'Glamour for Platypus'.
			spec
				package: 'Tamaris' with: [spec requires: #('SmaCC' 'SmaCCDev')];
				package: 'PetitStepExpress';
				package: 'Platypus' with: [spec requires: #('SmaCC' 'SmaCCDev')];
				package: 'xtra-platypus' with: [spec requires: #('Platypus')];
				package: 'SqPlatypus' with: [spec requires: #('xtra-platypus')];
				package: 'PlatypusPostLoad' with: [spec requires: #('SqPlatypus')]]].
! !

!ConfigurationOfPlatypus methodsFor: 'symbolics' stamp: 'AlainPlantec 4/30/2012 22:49'!
default: spec
	<symbolicVersion: #default>

	spec for: #'pharo' version: '1.0'.! !

!ConfigurationOfPlatypus methodsFor: 'accessing' stamp: 'AlainPlantec 4/30/2012 22:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPlatypus methodsFor: 'versions' stamp: 'AlainPlantec 5/1/2012 09:34'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'pharo' do: [
		spec description: 'Platypus for Pharo 1.4'.
		spec author: 'AlainPlantec'.
		spec timestamp: '09/26/2011 17:23:46'.
		spec
			package: 'SmaCC' with: 'SmaCC-lr.14';
			package: 'SmaCCDev' with: 'SmaCCDev-AlainPlantec.25'
			"package: 'Tamaris' with: 'Tamaris-AlainPlantec.101';
			package: 'Platypus' with: 'Platypus-AlainPlantec.82';
			package: 'SqPlatypus' with: 'SqPlatypus-AlainPlantec.62';
			package: 'xtra-platypus' with: 'xtra-platypus-AlainPlantec.67'"]
			
			
! !
